hdu 1342(DFS)

Lotto

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 2933    Accepted Submission(s): 1386

Problem Description

In
a Lotto I have ever played, one has to select 6 numbers from the set
{1,2,...,49}. A popular strategy to play Lotto - although it doesn‘t
increase your chance of winning - is to select a subset S containing k
(k>6) of these 49 numbers, and then play several games with choosing
numbers only from S. For example, for k=8 and S = {1,2,3,5,8,13,21,34}
there are 28 possible games: [1,2,3,5,8,13], [1,2,3,5,8,21],
[1,2,3,5,8,34], [1,2,3,5,13,21], ... [3,5,8,13,21,34].
Your job
is to write a program that reads in the number k and the set S and then
prints all possible games choosing numbers only from S.

Input

The
input file will contain one or more test cases. Each test case consists
of one line containing several integers separated from each other by
spaces. The first integer on the line will be the number k (6 < k
< 13). Then k integers, specifying the set S, will follow in
ascending order. Input will be terminated by a value of zero (0) for k.

Output

For
each test case, print all possible games, each game on one line. The
numbers of each game have to be sorted in ascending order and separated
from each other by exactly one space. The games themselves have to be
sorted lexicographically, that means sorted by the lowest number first,
then by the second lowest and so on, as demonstrated in the sample
output below. The test cases have to be separated from each other by
exactly one blank line. Do not put a blank line after the last test
case.

Sample Input

7 1 2 3 4 5 6 7

8 1 2 3 5 8 13 21 34

0

Sample Output

1 2 3 4 5 6

1 2 3 4 5 7

1 2 3 4 6 7

1 2 3 5 6 7

1 2 4 5 6 7

1 3 4 5 6 7

2 3 4 5 6 7

1 2 3 5 8 13

1 2 3 5 8 21

1 2 3 5 8 34

1 2 3 5 13 21

1 2 3 5 13 34

1 2 3 5 21 34

1 2 3 8 13 21

1 2 3 8 13 34

1 2 3 8 21 34

1 2 3 13 21 34

1 2 5 8 13 21

1 2 5 8 13 34

1 2 5 8 21 34

1 2 5 13 21 34

1 2 8 13 21 34

1 3 5 8 13 21

1 3 5 8 13 34

1 3 5 8 21 34

1 3 5 13 21 34

1 3 8 13 21 34

1 5 8 13 21 34

2 3 5 8 13 21

2 3 5 8 13 34

2 3 5 8 21 34

2 3 5 13 21 34

2 3 8 13 21 34

2 5 8 13 21 34

3 5 8 13 21 34

题意很简单 给你一个长度为k(>=6)的序列

让你输出一个长度为6的序列(递增)且这个序列至少要有一个数大于等于6

#include<iostream>
#include<cstdio>
#include<cmath>
#include<map>
#include<cstdlib>
#include<vector>
#include<set>
#include<queue>
#include<cstring>
#include<string.h>
#include<algorithm>
#define INF 0x3f3f3f3f
typedef long long ll;
typedef unsigned long long LL;
using namespace std;
int a[15],b[15];
int visited[15],n;
void DFS(int t,int num)
{
    if(num==6)
    {
        for(int i=0;i<5;i++)
            printf("%d ",b[i]);
        printf("%d\n",b[5]);
        return;
    }
    for(int i=t;i<n;i++)
    {
        if(visited[i]==0)
        {
            visited[i]=1;
            b[num]=a[i];
            DFS(i+1,num+1);
            visited[i]=0;
        }
    }
}

int main()
{
    int tt=0;
    while(scanf("%d",&n)!=EOF)
    {
        if(n==0)break;
        for(int i=0;i<n;i++)
            scanf("%d",&a[i]);
        if(tt)cout<<endl;
        tt++;
        memset(visited,0,sizeof(visited));
        DFS(0,0);
    }
    return 0;
}
时间: 2024-08-04 18:45:01

hdu 1342(DFS)的相关文章

HDU 2821Pusher(DFS )

题意:是一个游戏,可以玩下,就很清楚了,给你有箱子的图,你现在选择一个初始位置,并确定推的方向序列,规则:你要和箱子至少有一个空格才可以推,每次是先拿掉一个箱子,再把剩余的箱子(如果还存在的话)推向下一格,选择一个方向后要一直沿着这个方向走到不能走为止. #include<bits/stdc++.h> #define cl(a,b) memset(a,b,sizeof(a)); #define LL long long #define out(x) cout<<x<<e

hdu - 1072(dfs剪枝)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1072 思路:深搜每一个节点,并且进行剪枝,记录每一步上一次的s1,s2:如果之前走过的时间小于这一次, 就说明有更短的:路径,所以就不用继续遍历下去. #include<iostream> #include<cstdio> #include<cstring> using namespace std; int a[20][20],step[20][20],tim[20][20

hdu 1181(DFS)变 形 课

变形课 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)Total Submission(s): 22248    Accepted Submission(s): 8035 Problem Description 呃......变形课上Harry碰到了一点小麻烦,因为他并不像Hermione那样能够记住所有的咒语而随意的将一个棒球变成刺猬什么的,但是他发现了变形咒语的一个统一规

hdu 1015(DFS)

Safecracker Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 13237    Accepted Submission(s): 6897 Problem Description === Op tech briefing, 2002/11/02 06:42 CST === "The item is locked in a Klei

hdu 1142(DFS+dijkstra)

#include<iostream> #include<cstdio> #include<cmath> #include<map> #include<cstdlib> #include<vector> #include<set> #include<queue> #include<cstring> #include<string.h> #include<algorithm> t

HDU 1010:(DFS)

需要在确切的时间到达D处 此题特殊的地方在于剪枝方法:根据所处点与D处的曼哈顿距离和所剩步数的奇偶性剪枝.如果两者奇偶性不同,直接return #include"cstdio" #include"cmath" #include"cstring" #include"iostream" #include"queue" #define MAXN 10 using namespace std; int dx[4]=

hdu 5024 Wang Xifeng&#39;s Little Plot (dfs+暴力)

Wang Xifeng's Little Plot Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 194    Accepted Submission(s): 131 Problem Description <Dream of the Red Chamber>(also <The Story of the Stone>)

hdu 1258 Sum It Up (dfs+路径记录)

Sum It Up Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 3953    Accepted Submission(s): 2032 Problem Description Given a specified total t and a list of n integers, find all distinct sums usi

hdu 1501 Zipper (dfs+记忆化搜索)

Zipper Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6491    Accepted Submission(s): 2341 Problem Description Given three strings, you are to determine whether the third string can be formed